package org.openxma.addons.ui.table.customizer.xma.client;

import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Menu;

import at.spardat.xma.page.IDialogPage;
import at.spardat.xma.page.PageClient;

public class HeaderMenuDisposeListener implements Listener {
	/**
	 * 
	 */
	private final Menu headerMenu;
	private final PageClient page;

	public HeaderMenuDisposeListener(Menu headerMenu, PageClient page) {
		this.headerMenu = headerMenu;
		this.page = page;
	}

	public void handleEvent(Event event) {
		if (!page.isEventsEnabled())
			return;
		IDialogPage dialog = page.getDialogPage();
		try {
			dialog.setEventsEnabled(false);
			handleImpl();
		} catch (Exception exc) {
			page.showException(exc);
		} finally {
			dialog.setEventsEnabled(true);
		}
	}

	private void handleImpl() {
		headerMenu.dispose();
	}
}