package org.openxma.addons.ui.table.customizer.xma.client;

import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;

import at.spardat.xma.page.IDialogPage;
import at.spardat.xma.page.PageClient;

public class HeaderMenuListener implements Listener {
	/**
	 * 
	 */
	private final Menu headerMenu;
	private final PageClient page;
	private final Table table;

	public HeaderMenuListener(Menu headerMenu, PageClient page, Table table) {
		this.headerMenu = headerMenu;
		this.page = page;
		this.table = table;
	}

	public void handleEvent(Event event) {
		if (!page.isEventsEnabled())
			return;
		IDialogPage dialog = page.getDialogPage();
		try {
			dialog.setEventsEnabled(false);
			handleImpl(event);
		} catch (Exception exc) {
			page.showException(exc);
		} finally {
			dialog.setEventsEnabled(true);
		}
	}

	private void handleImpl(Event event) {
		Point pt = page.getComponent().getDisplay()
				.map(null, table, new Point(event.x, event.y));
		Rectangle clientArea = table.getClientArea();
		boolean header = clientArea.y <= pt.y
				&& pt.y < (clientArea.y + table.getHeaderHeight());
		if (header) {
			TableColumn found = null;
			found = getColumnByPoint(pt);
			headerMenu.setData("COLUMN", found);
			table.setMenu(headerMenu);
		}
	}

	private TableColumn getColumnByPoint(Point pt) {
		int x = 0;
		for (TableColumn column : table.getColumns()) {
			x += column.getWidth();
			if (pt.x <= x) {
				return column;
			}
		}
		return null;
	}
}